Mike Gerwitz

Activist for User Freedom

aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorMike Gerwitz <mike@mikegerwitz.com>2014-06-17 01:32:37 -0400
committerMike Gerwitz <mike@mikegerwitz.com>2014-06-17 01:37:31 -0400
commitc805501bea6a9e4bf7d87a638d35dd74379c71eb (patch)
treea65c2c31d1305b1a2945430c3763a7ceedf6c58c
parent7e8952a4d34873cc402a0e4a1e108ebe76fc6485 (diff)
downloadpkgsh-monad.tar.gz
pkgsh-monad.tar.bz2
pkgsh-monad.zip
Added cat-until{,-incl}monad
-rw-r--r--src/coreutils/cat.sh58
-rw-r--r--test/coreutils/test-cat-until.sh92
2 files changed, 150 insertions, 0 deletions
diff --git a/src/coreutils/cat.sh b/src/coreutils/cat.sh
new file mode 100644
index 0000000..d772359
--- /dev/null
+++ b/src/coreutils/cat.sh
@@ -0,0 +1,58 @@
+#!/bin/bash
+# Bash alternative to external cat call
+#
+# Copyright (C) 2014 Mike Gerwitz
+#
+# This file is part of pkgsh.
+#
+# pkgsh is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+# N.B. While this shell implementation may be faster for most use cases, the
+# external binary will likely be much faster for large streams.
+#
+# This also contains some convenience functions that are not part of
+# GNU coreutils.
+##
+
+[ -z $__PKGSH_INC_COREUTILS_CAT ] || return
+__PKGSH_INC_COREUTILS_CAT=1
+
+
+##
+# Echo characters from stdin up to (but not including) the provided
+# delimiter
+cat-until()
+{
+ local -r delim="${1?Missing terminating delimiter}"
+ local -r file="${2:-/dev/stdin}"
+ local -r data
+
+ read -rd"$delim" < "$file"
+ local -ri result=$?
+
+ echo -n "$REPLY"
+ return $result
+}
+
+
+##
+# Echo characters from stdin up to and including the provided delimiter
+cat-until-incl()
+{
+ # `cat-until` will validate
+ local -r delim="$1"
+ cat-until "$@" \
+ && echo -n "$delim"
+}
+
diff --git a/test/coreutils/test-cat-until.sh b/test/coreutils/test-cat-until.sh
new file mode 100644
index 0000000..c1ce282
--- /dev/null
+++ b/test/coreutils/test-cat-until.sh
@@ -0,0 +1,92 @@
+#!/bin/bash
+# Tests cat-until{,-incl}
+#
+# Copyright (C) 2014 Mike Gerwitz
+#
+# This file is part of pkgsh.
+#
+# pkgsh is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+##
+
+source src/coreutils/cat.sh
+
+
+test-cat-until-no-delim()
+{
+ local result
+ result="$( cat-until X <<< fooXbar )" \
+ || assert -z "non-zero exit"
+
+ assert "$result" == foo
+}
+
+
+test-cat-until-incl-has-delim()
+{
+ local result
+ result="$( cat-until-incl X <<< fooXbar )" \
+ || assert -z "non-zero exit"
+
+ assert "$result" == fooX
+}
+
+
+test-cat-until-from-file()
+{
+ local result
+ result="$( cat-until X <( echo fooXbar ) )" \
+ || assert -z "non-zero exit"
+
+ assert "$result" == foo
+}
+
+
+test-cat-until-incl-from-file()
+{
+ local result
+ result="$( cat-until-incl X <( echo fooXbar ) )" \
+ || assert -z "non-zero exit"
+
+ assert "$result" == fooX
+}
+
+
+test-cat-until-echoes-all-on-no-delim()
+{
+ local result
+ result="$( cat-until X <<< "foobar" )" \
+ && assert -z "returned successfully on missing delim"
+
+ assert $? -eq 1
+ assert "$result" == foobar
+}
+
+
+test-cat-until-incl-echoes-all-on-no-delim-without-trailing-delim()
+{
+ local result
+ result="$( cat-until-incl X <<< "foobar" )" \
+ && assert -z "returned successfully on missing delim"
+
+ assert "$result" == foobar
+}
+
+
+test-cat-until-no-delim
+test-cat-until-incl-has-delim
+test-cat-until-from-file
+test-cat-until-incl-from-file
+test-cat-until-echoes-all-on-no-delim
+test-cat-until-incl-echoes-all-on-no-delim-without-trailing-delim
+